#ifndef MODELH
#define MODELH

#include <d3dx9.h>
#include <wchar.h>
#include <Coef.h>
#include <map>

using namespace std;


class CMQOMaterial;
class CMQOObject;

class CModel
{
public:
	CModel();
	~CModel();

	int LoadMQO( LPDIRECT3DDEVICE9 pdev, WCHAR* wfile );
	int OnRender();
	int GetModelBound( MODELBOUND* dstb );

private:
	int InitParams();
	int DestroyObjs();
	int CreateMaterialTexture();

	int AddModelBound( MODELBOUND* mb, MODELBOUND* addmb );

	int DestroyMaterial();
	int DestroyObject();
public:
	int m_modelno;
	LPDIRECT3DDEVICE9 m_pdev;

	map<int, CMQOMaterial*> m_material;
	map<int, CMQOObject*> m_object;

	WCHAR m_filename[MAX_PATH];
	WCHAR m_dirname[MAX_PATH];
};

#endif