#ifndef MQOFACEH
#define MQOFACEH

#include <stdio.h>
#include <stdarg.h>

#include <coef.h>

#define DBGH
#include <dbg.h>


#ifndef MIKONAMELENG
	#define MIKONAMELENG 1024
#endif


class CMQOFace
{
public:
	CMQOFace();
	~CMQOFace();

	int SetParams( char* srcchar, int srcleng );

	int Dump();

	int CheckSameLine( CMQOFace* chkface, int* findflag );
	int SetInvFace( CMQOFace* srcface, int offset );

//	int SetMikoBoneIndex3( VEC3F* pbuf );
//	int SetMikoBoneIndex2( CMQOFace* srcface, int srcfacenum );

//	int SetMikoBoneName( char* srcname, int lrflag );
//	int CheckLRFlag( VEC3F* pointptr, int* lrflagptr );

private:
	void InitParams();

	int GetInt( int* dstint, char* srcchar, int pos, int srcleng, int* stepnum );
	int GetI64( __int64* dsti64, char* srcchar, int pos, int srcleng, int* stepnum );
	int GetFloat( float* dstfloat, char* srcchar, int pos, int srcleng, int* stepnum );

public:
	int m_faceno;
	int m_pointnum;
	int m_index[4];
	int m_materialno;
	
	int m_hasuv;
	D3DXVECTOR2 m_uv[4];

	__int64 m_col[4];
	int m_vcolsetflag;


//	CMQOFace* next;

// for mikoto bone
//	int mikobonetype; //MIKOBONE_NONE, MIKOBONE_NORMAL, MIKOBONE_float
//	int parentindex;
//	int childindex;
//	int hindex;

//	char bonename[MIKONAMELENG];
//	CMQOFace* parent;
//	CMQOFace* child;
//	CMQOFace* brother;

	int m_dirtyflag;
	int m_serialno;


};

#endif
