#ifndef MQOOBJECTH
#define MQOOBJECTH

#include <stdio.h>
#include <stdarg.h>

#include <coef.h>

#define DBGH
#include <dbg.h>

#include <d3dx9.h>

#include <map>
using namespace std;


class CMQOFace;
class CMQOMaterial;
class CPolyMesh3;
class CDispObj;


class CMQOObject
{
public:
	CMQOObject();
	~CMQOObject();

	int SetParams( char* srcchar, int srcleng );
	
	int SetVertex( int* vertnum, char* srcchar, int srcleng );
	int SetPointBuf( int vertno, char* srcchar, int srcleng );
	int SetPointBuf( unsigned char* srcptr, int srcnum );

	int SetFace( int* facenum, char* srcchar, int srcleng );
	int SetFaceBuf( int faceno, char* srcchar, int srcleng, int materialoffset );

	int CreateColor();
	int SetColor( char* srcchar, int srcleng );

	int Dump();

	int MakePolymesh3( LPDIRECT3DDEVICE9 pdev, map<int,CMQOMaterial*>& srcmat );
//	int MakeExtLine( map<int,CMQOMaterial*>& srcmat );

	int HasPolygon();
	int HasLine();

	int MultMat( D3DXMATRIX multmat );
	int Shift( D3DXVECTOR3 shiftvec );
	int Multiple( float multiple );

	int InitFaceDirtyFlag();

/***
	int IsMikoBone();
	int SetMikoBoneIndex3();
	int SetMikoBoneIndex2();
	int GetTopLevelMikoBone( CMQOFace** pptopface, int* topnumptr, int maxnum );
	int SetTreeMikoBone( CMQOFace* srctopface, CMQOMaterial* mathead );
	int CheckSameMikoBone();
	int CheckLoopedMikoBoneReq( CMQOMaterial* mathead, CMQOFace* faceptr, int* isloopedptr, int* jointnumptr );
	int SetMikoBoneName( CMQOMaterial* mathead );
	int SetMikoFloatBoneName();

	int GetParentLock( CMQOFace* srcface, CVec3f* locptr );
	int GetChildLock( CMQOFace* srcface, CVec3f* locptr );
	int GetHLock( CMQOFace* srcface, CVec3f* lockptr );

	void DumpMikoBoneReq( CMQOFace* srcface, int depth );
***/

private:
	void InitParams();

	int GetName( char* dstchar, int dstleng, char* srcchar, int pos, int srcleng );
	int GetInt( int* dstint, char* srcchar, int pos, int srcleng, int* stepnum );
	int GetFloat( float* dstfloat, char* srcchar, int pos, int srcleng, int* stepnum );

	int MakeLatheBuf();
	int MakeMirrorBuf();

	int FindConnectFace( int issetface );
	int MakeMirrorPointAndFace( int axis, int doconnect );

	int CheckMirrorDis( D3DXVECTOR3* pbuf, CMQOFace* fbuf, int lno, int pnum );

	int CheckFaceSameChildIndex( CMQOFace* srcface, int chkno, CMQOFace** ppfindface );
	int FindFaceSameParentIndex( CMQOFace* srcface, int chkno, CMQOFace** ppfindface, int* findnum, int maxnum );
	int IsSameMikoBone( CMQOFace* face1, CMQOFace* face2 );
	int IsSameFaceIndex( CMQOFace* face1, CMQOFace* face2 );
	int IsSameFacePos( CMQOFace* face1, CMQOFace* face2, VEC3F* pointptr );


public:
	int m_objectno;
	char m_name[256];

	int m_patch;
	int m_segment;

	int m_visible;
	int m_locking;

	int m_shading;
	float m_facet;
	D3DXVECTOR4 m_color;
	int m_color_type;
	int m_mirror;
	int m_mirror_axis;
	int m_issetmirror_dis;
	float m_mirror_dis;

	int m_lathe;
	int m_lathe_axis;
	int m_lathe_seg;
	int m_vertex;
	//BVertex;
	int m_face;

	D3DXVECTOR3* m_pointbuf;
	CMQOFace* m_facebuf;

	int m_hascolor;
	D3DXVECTOR4* m_colorbuf;

	int m_vertex2;
	int m_face2;
	D3DXVECTOR3* m_pointbuf2;
	CMQOFace* m_facebuf2;
	D3DXVECTOR4* m_colorbuf2;

	int m_connectnum;
	CMQOFace* m_connectface;

	CPolyMesh3* m_pm3;
	D3DXMATRIX m_multmat;

	CDispObj* m_dispobj;

//	CMQOObject* next;
};

#endif